install.sh 16 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502
  1. #!/bin/sh
  2. #
  3. # This script should be run via curl:
  4. # sh -c "$(curl -fsSL https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
  5. # or via wget:
  6. # sh -c "$(wget -qO- https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
  7. # or via fetch:
  8. # sh -c "$(fetch -o - https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
  9. #
  10. # As an alternative, you can first download the install script and run it afterwards:
  11. # wget https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh
  12. # sh install.sh
  13. #
  14. # You can tweak the install behavior by setting variables when running the script. For
  15. # example, to change the path to the Oh My Zsh repository:
  16. # ZSH=~/.zsh sh install.sh
  17. #
  18. # Respects the following environment variables:
  19. # ZSH - path to the Oh My Zsh repository folder (default: $HOME/.oh-my-zsh)
  20. # REPO - name of the GitHub repo to install from (default: ohmyzsh/ohmyzsh)
  21. # REMOTE - full remote URL of the git repo to install (default: GitHub via HTTPS)
  22. # BRANCH - branch to check out immediately after install (default: master)
  23. #
  24. # Other options:
  25. # CHSH - 'no' means the installer will not change the default shell (default: yes)
  26. # RUNZSH - 'no' means the installer will not run zsh after the install (default: yes)
  27. # KEEP_ZSHRC - 'yes' means the installer will not replace an existing .zshrc (default: no)
  28. #
  29. # You can also pass some arguments to the install script to set some these options:
  30. # --skip-chsh: has the same behavior as setting CHSH to 'no'
  31. # --unattended: sets both CHSH and RUNZSH to 'no'
  32. # --keep-zshrc: sets KEEP_ZSHRC to 'yes'
  33. # For example:
  34. # sh install.sh --unattended
  35. # or:
  36. # sh -c "$(curl -fsSL https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)" "" --unattended
  37. #
  38. set -e
  39. # Track if $ZSH was provided
  40. custom_zsh=${ZSH:+yes}
  41. # Default settings
  42. ZSH=${ZSH:-~/.oh-my-zsh}
  43. REPO=${REPO:-ohmyzsh/ohmyzsh}
  44. REMOTE=${REMOTE:-https://github.com/${REPO}.git}
  45. BRANCH=${BRANCH:-master}
  46. # Other options
  47. CHSH=${CHSH:-yes}
  48. RUNZSH=${RUNZSH:-yes}
  49. KEEP_ZSHRC=${KEEP_ZSHRC:-no}
  50. # Sane defaults
  51. USER=${USER:-$(whoami)}
  52. command_exists() {
  53. command -v "$@" >/dev/null 2>&1
  54. }
  55. user_can_sudo() {
  56. # Check if sudo is installed
  57. command_exists sudo || return 1
  58. # The following command has 3 parts:
  59. #
  60. # 1. Run `sudo` with `-v`. Does the following:
  61. # • with privilege: asks for a password immediately.
  62. # • without privilege: exits with error code 1 and prints the message:
  63. # Sorry, user <username> may not run sudo on <hostname>
  64. #
  65. # 2. Pass `-n` to `sudo` to tell it to not ask for a password. If the
  66. # password is not required, the command will finish with exit code 0.
  67. # If one is required, sudo will exit with error code 1 and print the
  68. # message:
  69. # sudo: a password is required
  70. #
  71. # 3. Check for the words "may not run sudo" in the output to really tell
  72. # whether the user has privileges or not. For that we have to make sure
  73. # to run `sudo` in the default locale (with `LANG=`) so that the message
  74. # stays consistent regardless of the user's locale.
  75. #
  76. ! LANG= sudo -n -v 2>&1 | grep -q "may not run sudo"
  77. }
  78. # The [ -t 1 ] check only works when the function is not called from
  79. # a subshell (like in `$(...)` or `(...)`, so this hack redefines the
  80. # function at the top level to always return false when stdout is not
  81. # a tty.
  82. if [ -t 1 ]; then
  83. is_tty() {
  84. true
  85. }
  86. else
  87. is_tty() {
  88. false
  89. }
  90. fi
  91. # This function uses the logic from supports-hyperlinks[1][2], which is
  92. # made by Kat Marchán (@zkat) and licensed under the Apache License 2.0.
  93. # [1] https://github.com/zkat/supports-hyperlinks
  94. # [2] https://crates.io/crates/supports-hyperlinks
  95. #
  96. # Copyright (c) 2021 Kat Marchán
  97. #
  98. # Licensed under the Apache License, Version 2.0 (the "License");
  99. # you may not use this file except in compliance with the License.
  100. # You may obtain a copy of the License at
  101. #
  102. # http://www.apache.org/licenses/LICENSE-2.0
  103. #
  104. # Unless required by applicable law or agreed to in writing, software
  105. # distributed under the License is distributed on an "AS IS" BASIS,
  106. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  107. # See the License for the specific language governing permissions and
  108. # limitations under the License.
  109. supports_hyperlinks() {
  110. # $FORCE_HYPERLINK must be set and be non-zero (this acts as a logic bypass)
  111. if [ -n "$FORCE_HYPERLINK" ]; then
  112. [ "$FORCE_HYPERLINK" != 0 ]
  113. return $?
  114. fi
  115. # If stdout is not a tty, it doesn't support hyperlinks
  116. is_tty || return 1
  117. # DomTerm terminal emulator (domterm.org)
  118. if [ -n "$DOMTERM" ]; then
  119. return 0
  120. fi
  121. # VTE-based terminals above v0.50 (Gnome Terminal, Guake, ROXTerm, etc)
  122. if [ -n "$VTE_VERSION" ]; then
  123. [ $VTE_VERSION -ge 5000 ]
  124. return $?
  125. fi
  126. # If $TERM_PROGRAM is set, these terminals support hyperlinks
  127. case "$TERM_PROGRAM" in
  128. Hyper|iTerm.app|terminology|WezTerm) return 0 ;;
  129. esac
  130. # kitty supports hyperlinks
  131. if [ "$TERM" = xterm-kitty ]; then
  132. return 0
  133. fi
  134. # Windows Terminal or Konsole also support hyperlinks
  135. if [ -n "$WT_SESSION" ] || [ -n "$KONSOLE_VERSION" ]; then
  136. return 0
  137. fi
  138. return 1
  139. }
  140. # Adapted from code and information by Anton Kochkov (@XVilka)
  141. # Source: https://gist.github.com/XVilka/8346728
  142. supports_truecolor() {
  143. case "$COLORTERM" in
  144. truecolor|24bit) return 0 ;;
  145. esac
  146. case "$TERM" in
  147. iterm |\
  148. tmux-truecolor |\
  149. linux-truecolor |\
  150. xterm-truecolor |\
  151. screen-truecolor) return 0 ;;
  152. esac
  153. return 1
  154. }
  155. fmt_link() {
  156. # $1: text, $2: url, $3: fallback mode
  157. if supports_hyperlinks; then
  158. printf '\033]8;;%s\a%s\033]8;;\a\n' "$2" "$1"
  159. return
  160. fi
  161. case "$3" in
  162. --text) printf '%s\n' "$1" ;;
  163. --url|*) fmt_underline "$2" ;;
  164. esac
  165. }
  166. fmt_underline() {
  167. is_tty && printf '\033[4m%s\033[24m\n' "$*" || printf '%s\n' "$*"
  168. }
  169. # shellcheck disable=SC2016 # backtick in single-quote
  170. fmt_code() {
  171. is_tty && printf '`\033[2m%s\033[22m`\n' "$*" || printf '`%s`\n' "$*"
  172. }
  173. fmt_error() {
  174. printf '%sError: %s%s\n' "${FMT_BOLD}${FMT_RED}" "$*" "$FMT_RESET" >&2
  175. }
  176. setup_color() {
  177. # Only use colors if connected to a terminal
  178. if ! is_tty; then
  179. FMT_RAINBOW=""
  180. FMT_RED=""
  181. FMT_GREEN=""
  182. FMT_YELLOW=""
  183. FMT_BLUE=""
  184. FMT_BOLD=""
  185. FMT_RESET=""
  186. return
  187. fi
  188. if supports_truecolor; then
  189. FMT_RAINBOW="
  190. $(printf '\033[38;2;255;0;0m')
  191. $(printf '\033[38;2;255;97;0m')
  192. $(printf '\033[38;2;247;255;0m')
  193. $(printf '\033[38;2;0;255;30m')
  194. $(printf '\033[38;2;77;0;255m')
  195. $(printf '\033[38;2;168;0;255m')
  196. $(printf '\033[38;2;245;0;172m')
  197. "
  198. else
  199. FMT_RAINBOW="
  200. $(printf '\033[38;5;196m')
  201. $(printf '\033[38;5;202m')
  202. $(printf '\033[38;5;226m')
  203. $(printf '\033[38;5;082m')
  204. $(printf '\033[38;5;021m')
  205. $(printf '\033[38;5;093m')
  206. $(printf '\033[38;5;163m')
  207. "
  208. fi
  209. FMT_RED=$(printf '\033[31m')
  210. FMT_GREEN=$(printf '\033[32m')
  211. FMT_YELLOW=$(printf '\033[33m')
  212. FMT_BLUE=$(printf '\033[34m')
  213. FMT_BOLD=$(printf '\033[1m')
  214. FMT_RESET=$(printf '\033[0m')
  215. }
  216. setup_ohmyzsh() {
  217. # Prevent the cloned repository from having insecure permissions. Failing to do
  218. # so causes compinit() calls to fail with "command not found: compdef" errors
  219. # for users with insecure umasks (e.g., "002", allowing group writability). Note
  220. # that this will be ignored under Cygwin by default, as Windows ACLs take
  221. # precedence over umasks except for filesystems mounted with option "noacl".
  222. umask g-w,o-w
  223. echo "${FMT_BLUE}Cloning Oh My Zsh...${FMT_RESET}"
  224. command_exists git || {
  225. fmt_error "git is not installed"
  226. exit 1
  227. }
  228. ostype=$(uname)
  229. if [ -z "${ostype%CYGWIN*}" ] && git --version | grep -q msysgit; then
  230. fmt_error "Windows/MSYS Git is not supported on Cygwin"
  231. fmt_error "Make sure the Cygwin git package is installed and is first on the \$PATH"
  232. exit 1
  233. fi
  234. # Manual clone with git config options to support git < v1.7.2
  235. git init "$ZSH" && cd "$ZSH" \
  236. && git config core.eol lf \
  237. && git config core.autocrlf false \
  238. && git config fsck.zeroPaddedFilemode ignore \
  239. && git config fetch.fsck.zeroPaddedFilemode ignore \
  240. && git config receive.fsck.zeroPaddedFilemode ignore \
  241. && git config oh-my-zsh.remote origin \
  242. && git config oh-my-zsh.branch "$BRANCH" \
  243. && git remote add origin "$REMOTE" \
  244. && git fetch --depth=1 origin \
  245. && git checkout -b "$BRANCH" "origin/$BRANCH" || {
  246. rm -rf "$ZSH"
  247. fmt_error "git clone of oh-my-zsh repo failed"
  248. exit 1
  249. }
  250. echo
  251. }
  252. setup_zshrc() {
  253. # Keep most recent old .zshrc at .zshrc.pre-oh-my-zsh, and older ones
  254. # with datestamp of installation that moved them aside, so we never actually
  255. # destroy a user's original zshrc
  256. echo "${FMT_BLUE}Looking for an existing zsh config...${FMT_RESET}"
  257. # Must use this exact name so uninstall.sh can find it
  258. OLD_ZSHRC=~/.zshrc.pre-oh-my-zsh
  259. if [ -f ~/.zshrc ] || [ -h ~/.zshrc ]; then
  260. # Skip this if the user doesn't want to replace an existing .zshrc
  261. if [ "$KEEP_ZSHRC" = yes ]; then
  262. echo "${FMT_YELLOW}Found ~/.zshrc.${FMT_RESET} ${FMT_GREEN}Keeping...${FMT_RESET}"
  263. return
  264. fi
  265. if [ -e "$OLD_ZSHRC" ]; then
  266. OLD_OLD_ZSHRC="${OLD_ZSHRC}-$(date +%Y-%m-%d_%H-%M-%S)"
  267. if [ -e "$OLD_OLD_ZSHRC" ]; then
  268. fmt_error "$OLD_OLD_ZSHRC exists. Can't back up ${OLD_ZSHRC}"
  269. fmt_error "re-run the installer again in a couple of seconds"
  270. exit 1
  271. fi
  272. mv "$OLD_ZSHRC" "${OLD_OLD_ZSHRC}"
  273. echo "${FMT_YELLOW}Found old ~/.zshrc.pre-oh-my-zsh." \
  274. "${FMT_GREEN}Backing up to ${OLD_OLD_ZSHRC}${FMT_RESET}"
  275. fi
  276. echo "${FMT_YELLOW}Found ~/.zshrc.${FMT_RESET} ${FMT_GREEN}Backing up to ${OLD_ZSHRC}${FMT_RESET}"
  277. mv ~/.zshrc "$OLD_ZSHRC"
  278. fi
  279. echo "${FMT_GREEN}Using the Oh My Zsh template file and adding it to ~/.zshrc.${FMT_RESET}"
  280. # Replace $HOME path with '$HOME' in $ZSH variable in .zshrc file
  281. omz=$(echo "$ZSH" | sed "s|^$HOME/|\$HOME/|")
  282. sed "s|^export ZSH=.*$|export ZSH=\"${omz}\"|" "$ZSH/templates/zshrc.zsh-template" > ~/.zshrc-omztemp
  283. mv -f ~/.zshrc-omztemp ~/.zshrc
  284. echo
  285. }
  286. setup_shell() {
  287. # Skip setup if the user wants or stdin is closed (not running interactively).
  288. if [ "$CHSH" = no ]; then
  289. return
  290. fi
  291. # If this user's login shell is already "zsh", do not attempt to switch.
  292. if [ "$(basename -- "$SHELL")" = "zsh" ]; then
  293. return
  294. fi
  295. # If this platform doesn't provide a "chsh" command, bail out.
  296. if ! command_exists chsh; then
  297. cat <<EOF
  298. I can't change your shell automatically because this system does not have chsh.
  299. ${FMT_BLUE}Please manually change your default shell to zsh${FMT_RESET}
  300. EOF
  301. return
  302. fi
  303. echo "${FMT_BLUE}Time to change your default shell to zsh:${FMT_RESET}"
  304. # Prompt for user choice on changing the default login shell
  305. printf '%sDo you want to change your default shell to zsh? [Y/n]%s ' \
  306. "$FMT_YELLOW" "$FMT_RESET"
  307. read -r opt
  308. case $opt in
  309. y*|Y*|"") ;;
  310. n*|N*) echo "Shell change skipped."; return ;;
  311. *) echo "Invalid choice. Shell change skipped."; return ;;
  312. esac
  313. # Check if we're running on Termux
  314. case "$PREFIX" in
  315. *com.termux*) termux=true; zsh=zsh ;;
  316. *) termux=false ;;
  317. esac
  318. if [ "$termux" != true ]; then
  319. # Test for the right location of the "shells" file
  320. if [ -f /etc/shells ]; then
  321. shells_file=/etc/shells
  322. elif [ -f /usr/share/defaults/etc/shells ]; then # Solus OS
  323. shells_file=/usr/share/defaults/etc/shells
  324. else
  325. fmt_error "could not find /etc/shells file. Change your default shell manually."
  326. return
  327. fi
  328. # Get the path to the right zsh binary
  329. # 1. Use the most preceding one based on $PATH, then check that it's in the shells file
  330. # 2. If that fails, get a zsh path from the shells file, then check it actually exists
  331. if ! zsh=$(command -v zsh) || ! grep -qx "$zsh" "$shells_file"; then
  332. if ! zsh=$(grep '^/.*/zsh$' "$shells_file" | tail -n 1) || [ ! -f "$zsh" ]; then
  333. fmt_error "no zsh binary found or not present in '$shells_file'"
  334. fmt_error "change your default shell manually."
  335. return
  336. fi
  337. fi
  338. fi
  339. # We're going to change the default shell, so back up the current one
  340. if [ -n "$SHELL" ]; then
  341. echo "$SHELL" > ~/.shell.pre-oh-my-zsh
  342. else
  343. grep "^$USER:" /etc/passwd | awk -F: '{print $7}' > ~/.shell.pre-oh-my-zsh
  344. fi
  345. echo "Changing your shell to $zsh..."
  346. # Check if user has sudo privileges to run `chsh` with or without `sudo`
  347. #
  348. # This allows the call to succeed without password on systems where the
  349. # user does not have a password but does have sudo privileges, like in
  350. # Google Cloud Shell.
  351. #
  352. # On systems that don't have a user with passwordless sudo, the user will
  353. # be prompted for the password either way, so this shouldn't cause any issues.
  354. #
  355. if user_can_sudo; then
  356. sudo -k chsh -s "$zsh" "$USER" # -k forces the password prompt
  357. else
  358. chsh -s "$zsh" "$USER" # run chsh normally
  359. fi
  360. # Check if the shell change was successful
  361. if [ $? -ne 0 ]; then
  362. fmt_error "chsh command unsuccessful. Change your default shell manually."
  363. else
  364. export SHELL="$zsh"
  365. echo "${FMT_GREEN}Shell successfully changed to '$zsh'.${FMT_RESET}"
  366. fi
  367. echo
  368. }
  369. # shellcheck disable=SC2183 # printf string has more %s than arguments ($FMT_RAINBOW expands to multiple arguments)
  370. print_success() {
  371. printf '%s %s__ %s %s %s %s %s__ %s\n' $FMT_RAINBOW $FMT_RESET
  372. printf '%s ____ %s/ /_ %s ____ ___ %s__ __ %s ____ %s_____%s/ /_ %s\n' $FMT_RAINBOW $FMT_RESET
  373. printf '%s / __ \\%s/ __ \\ %s / __ `__ \\%s/ / / / %s /_ / %s/ ___/%s __ \\ %s\n' $FMT_RAINBOW $FMT_RESET
  374. printf '%s/ /_/ /%s / / / %s / / / / / /%s /_/ / %s / /_%s(__ )%s / / / %s\n' $FMT_RAINBOW $FMT_RESET
  375. printf '%s\\____/%s_/ /_/ %s /_/ /_/ /_/%s\\__, / %s /___/%s____/%s_/ /_/ %s\n' $FMT_RAINBOW $FMT_RESET
  376. printf '%s %s %s %s /____/ %s %s %s %s....is now installed!%s\n' $FMT_RAINBOW $FMT_GREEN $FMT_RESET
  377. printf '\n'
  378. printf '\n'
  379. printf "%s %s %s\n" "Before you scream ${FMT_BOLD}${FMT_YELLOW}Oh My Zsh!${FMT_RESET} look over the" \
  380. "$(fmt_code "$(fmt_link ".zshrc" "file://$HOME/.zshrc" --text)")" \
  381. "file to select plugins, themes, and options."
  382. printf '\n'
  383. printf '%s\n' "• Follow us on Twitter: $(fmt_link @ohmyzsh https://twitter.com/ohmyzsh)"
  384. printf '%s\n' "• Join our Discord community: $(fmt_link "Discord server" https://discord.gg/ohmyzsh)"
  385. printf '%s\n' "• Get stickers, t-shirts, coffee mugs and more: $(fmt_link "Planet Argon Shop" https://shop.planetargon.com/collections/oh-my-zsh)"
  386. printf '%s\n' $FMT_RESET
  387. }
  388. main() {
  389. # Run as unattended if stdin is not a tty
  390. if [ ! -t 0 ]; then
  391. RUNZSH=no
  392. CHSH=no
  393. fi
  394. # Parse arguments
  395. while [ $# -gt 0 ]; do
  396. case $1 in
  397. --unattended) RUNZSH=no; CHSH=no ;;
  398. --skip-chsh) CHSH=no ;;
  399. --keep-zshrc) KEEP_ZSHRC=yes ;;
  400. esac
  401. shift
  402. done
  403. setup_color
  404. if ! command_exists zsh; then
  405. echo "${FMT_YELLOW}Zsh is not installed.${FMT_RESET} Please install zsh first."
  406. exit 1
  407. fi
  408. if [ -d "$ZSH" ]; then
  409. echo "${FMT_YELLOW}The \$ZSH folder already exists ($ZSH).${FMT_RESET}"
  410. if [ "$custom_zsh" = yes ]; then
  411. cat <<EOF
  412. You ran the installer with the \$ZSH setting or the \$ZSH variable is
  413. exported. You have 3 options:
  414. 1. Unset the ZSH variable when calling the installer:
  415. $(fmt_code "ZSH= sh install.sh")
  416. 2. Install Oh My Zsh to a directory that doesn't exist yet:
  417. $(fmt_code "ZSH=path/to/new/ohmyzsh/folder sh install.sh")
  418. 3. (Caution) If the folder doesn't contain important information,
  419. you can just remove it with $(fmt_code "rm -r $ZSH")
  420. EOF
  421. else
  422. echo "You'll need to remove it if you want to reinstall."
  423. fi
  424. exit 1
  425. fi
  426. setup_ohmyzsh
  427. setup_zshrc
  428. setup_shell
  429. print_success
  430. if [ $RUNZSH = no ]; then
  431. echo "${FMT_YELLOW}Run zsh to try it out.${FMT_RESET}"
  432. exit
  433. fi
  434. exec zsh -l
  435. }
  436. main "$@"